# -*- encoding: utf-8 -*-

from django.contrib import admin

from .models import (
    Subscription,
    SavedGuilds,
    Filter,
    SubChannel,
    TrackedContent,
    ArticleMutator,
    GuildSettings,

    # temp rewrite
    r_Server,
    r_ContentFilter,
    r_MessageMutator,
    r_MessageStyle,
    r_Subscription,
    r_Content,
    r_UniqueContentRule
)


@admin.register(Subscription)
class SubscriptionAdmin(admin.ModelAdmin):
    list_display = [
        "id", "name", "url", "guild_id",
        "creation_datetime", "active"
    ]

@admin.register(SubChannel)
class SubChannelAdmin(admin.ModelAdmin):
    list_display = [
        "id", "channel_id", "subscription"
    ]


@admin.register(Filter)
class FilterAdmin(admin.ModelAdmin):
    list_display = [
        "id", "name", "guild_id"
    ]


@admin.register(TrackedContent)
class TrackedContentAdmin(admin.ModelAdmin):
    list_display = [
        "guid", "title", "url", "subscription", "blocked", "creation_datetime"
    ]


@admin.register(SavedGuilds)
class SavedGuildAdmin(admin.ModelAdmin):
    list_display = [
        "id", "name", "icon"
    ]


@admin.register(ArticleMutator)
class ArticleMutatorAdmin(admin.ModelAdmin):
    list_display = [
        "id", "name", "value"
    ]

@admin.register(GuildSettings)
class GuildSettingsAdmin(admin.ModelAdmin):
    list_display = [
        "id", "guild_id", "default_embed_colour", "active"
    ]


#region rewrite


@admin.register(r_Server)
class r_ServerAdmin(admin.ModelAdmin):
    list_display = ["id", "name", "icon_hash", "active"]


@admin.register(r_ContentFilter)
class r_ContentFilterAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "name",
        "match",
        "matching_algorithm",
        "is_insensitive",
        "is_whitelist"
    ]


@admin.register(r_MessageMutator)
class r_MessageMutatorAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "name",
        "value"
    ]


@admin.register(r_MessageStyle)
class r_MessageStyleAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "is_embed",
        "is_hyperlinked",
        "show_author",
        "show_timestamp",
        "show_images",
        "fetch_images",
        "title_mutator",
        "description_mutator"
    ]


@admin.register(r_Subscription)
class r_Subscription(admin.ModelAdmin):
    list_display = [
        "id",
        "server",
        "name",
        "url",
        "created_at",
        "updated_at",
        "extra_notes",
        "active",
        "message_style"
    ]


@admin.register(r_Content)
class r_ContentAdmin(admin.ModelAdmin):
    list_display = [
        "id",
        "subscription",
        "item_id",
        "item_guid",
        "item_url",
        "item_title",
        "item_content_hash"
    ]


@admin.register(r_UniqueContentRule)
class r_UniqueContentRule(admin.ModelAdmin):
    list_display = [
        "id",
        "name",
        "value"
    ]
